##jeux systematiquement rduit

rm(list=ls())
graphics.off()
source("IM_proc_eval.r")


m<<-20#number of imputed data sets
nsim<<-1000#number of patterns
p<<-0.3#percentage of missign values

res<-as.data.frame(matrix(NA,4,8,dimnames=list(c("Decathlon","Isoprenoid","Ozone","Wine"),rep(c("Amelia","BayesMI","BayesMIPCA","CC"),2))))
RES<-list(mean=res,beta=res,cor=res)

simulate.real <- function(don,nsim,m=20,formule, S, p, verbose=F, methods=1:4, kapa=0,predictorMatrix=(1 - diag(1, ncol(data))),empri=0, L=100, Lstart=1000,v1.cor,v2.cor,...){
  res_beta <- array(NA,dim=c(4, nsim, 3))
  res_mean <- array(NA,dim=c(4, nsim, 3))
  res_cor <- array(NA,dim=c(4, nsim, 3))
  dimnames(res_beta) <- list(c("LD","amelia","BayesMI","BayesMIPCA"), as.character(1:nsim),c("est","lo 95","hi 95"))
  dimnames(res_mean)<-dimnames(res_cor)<-dimnames(res_beta)
  im <- c("LD","amelia","norm","BayesMIPCA")
  for(i in 1:nsim){
    print(i)
    set.seed(i)
    data <- Missing(don,p=p,S=S)
    if(1%in%methods){
      temp<-test.impute(data, method=im[1],formula=formule,v1.cor=v1.cor,v2.cor=v2.cor)
      res_beta[1,i,] <- temp[[1]]
      res_mean[1,i,] <- temp[[2]]
      res_cor[1,i,] <- temp[[3]]
    }
    if(2%in%methods){
      temp<-test.impute(data, method=im[2],m=m,empri=empri,formula=formule,verbose=verbose,v1.cor=v1.cor,v2.cor=v2.cor)
      res_beta[2,i,] <- temp[[1]]
      res_mean[2,i,] <- temp[[2]]
      res_cor[2,i,] <- temp[[3]]
    }
    if (3%in%methods){
      temp<-test.impute(data, method=im[3],m=m,kapa=kapa,formula=formule,verbose=verbose,predictorMatrix=predictorMatrix,v1.cor=v1.cor,v2.cor=v2.cor)
      res_beta[3,i,] <- temp[[1]]
      res_mean[3,i,] <- temp[[2]]
      res_cor[3,i,] <- temp[[3]]
    }
    if(4%in%methods){
      temp<-test.impute(data, method=im[4],S=S,formula=formule,m=m,verbose=verbose,L=L,Lstart=Lstart,v1.cor=v1.cor,v2.cor=v2.cor)
      res_beta[4,i,] <- temp[[1]]
      res_mean[4,i,] <- temp[[2]]
      res_cor[4,i,] <- temp[[3]]
    }

  }
  return(list(beta=res_beta,mean=res_mean,cor=res_cor))
}

##confidence intervals for complete case
ICcc<-function(X,formule,v1.cor,v2.cor){
    l.mean<-l.beta<-l.cor<-c()
      temp<-LD(X,formula=formule,v1.cor,v2.cor)
      l.mean<-c(l.mean,temp[["mean"]][["hi 95"]]-temp[["mean"]][["lo 95"]])
      l.beta<-c(l.beta,temp[["beta"]][["hi 95"]]-temp[["beta"]][["lo 95"]])
      l.cor<-c(l.cor,temp[["cor"]][["hi 95"]]-temp[["cor"]][["lo 95"]])
    return(list(mean=l.mean,beta=l.beta,cor=l.cor))
}


################################# decathlon #################################
  data(decathlon)
  Decathlon<-scale(decathlon[,-c(11,13)])
  Decathlon<-as.data.frame(Decathlon[,c(11,1:10)])
  colnames(Decathlon)<-c("y",paste("x",1:10,sep=""))

  S<-estim_ncp(Decathlon)$ncp
  kapa<-0
  methods<-c(3,4)

  beta_true<-lm(y~.,data=Decathlon)$coeff[2]  #correspond au 100m
  cor_true<-cor(Decathlon[,4],Decathlon[,8])
  mean_true<-0
  formule<-concat(c("y~",paste(paste("x",1:9,sep=""),"+",sep=""),"x",10))
  res.article.decathlon<-simulate.real(don=Decathlon,nsim=nsim,v.na=c(1:11),p=p,Xtild=NULL,formule=formule,S=S,m=m,v1.cor=4,v2.cor=8,methods=methods,empri=empri,verbose=F,kapa=kapa)

  ICcomp<-ICcc(Decathlon,formule=concat(c("y~",paste(paste("x",1:9,sep=""),"+",sep=""),"x",10)),4,8)

  RES$mean["Decathlon",c(2,3,4)]<-c(na.omit(rowMeans(res.article.decathlon$mean[,,1])),mean_true)
  RES$mean["Decathlon",c(6,7)]<-t(summarize.results(res.article.decathlon,true_beta=beta_true,true_mean=mean_true,true_cor=cor_true,digits=3)$mean[2,])
  RES$mean["Decathlon",8]<-ICcomp$mean
  
  RES$beta["Decathlon",c(2,3,4)]<-c(na.omit(rowMeans(res.article.decathlon$beta[,,1])),beta_true)
  RES$beta["Decathlon",c(6,7)]<-t(summarize.results(res.article.decathlon,true_beta=beta_true,true_mean=mean_true,true_cor=cor_true,digits=3)$beta[2,])
  RES$beta["Decathlon",8]<-ICcomp$beta
  
  RES$cor["Decathlon",c(2,3,4)]<-c(na.omit(rowMeans(res.article.decathlon$cor[,,1])),cor_true)
  RES$cor["Decathlon",c(6,7)]<-round(100*(-1+summarize.results(res.article.decathlon,true_beta=beta_true,true_mean=mean_true,true_cor=cor_true)$cor[2,]/ICcomp$cor),0)
  RES$cor["Decathlon",8]<-round(ICcomp$cor,3)

################################# isoprenoid #################################
  #genes
  Isoprenoid<-read.table("Isoprenoid.data.txt",sep=" ",header=T,skip=6)[,-c(1:6)]
  Isoprenoid<-as.data.frame(scale(t(Isoprenoid[,-119])))
  Isoprenoid<-Isoprenoid[,c(1,8,2:7,9:ncol(Isoprenoid))]
  colnames(Isoprenoid)<-c("y",paste("x",1:(ncol(Isoprenoid)-1),sep=""))
  
  S<-estim_ncp(Isoprenoid,method="Smooth")$ncp#21 pour gcv
  methods<-c(3,4)  #amelia hs
  kapa<-0

  beta_true<-lm(y~x1+x9+x11+x22+x29+x31+x35,data=Isoprenoid)$coeff[2]
  cor_true<-cor(Isoprenoid[,c(11,29)])[1,2]
  mean_true<-0
  formule<- "y~x1+x9+x11+x22+x29+x31+x35"
  res.article.isoprenoid<-simulate.real(don=Isoprenoid,nsim=nsim,v.na=c(1:ncol(Isoprenoid)),p=p,Xtild=NULL,formula=formule,S=S,m=m,v1.cor=11,v2.cor=29,methods=methods,empri=empri,verbose=T,kapa=kapa)
  ICcomp<-ICcc(Isoprenoid,formule,11,29)

  RES$mean["Isoprenoid",c(2,3,4)]<-c(na.omit(rowMeans(res.article.isoprenoid$mean[,,1])),mean_true)
  RES$mean["Isoprenoid",c(6,7)]<-t(summarize.results(res.article.isoprenoid,true_beta=beta_true,true_mean=mean_true,true_cor=cor_true,digits=3)$mean[2,])
  RES$mean["Isoprenoid",8]<-ICcomp$mean
  
  RES$beta["Isoprenoid",c(2,3,4)]<-c(na.omit(rowMeans(res.article.isoprenoid$beta[,,1])),beta_true)
  RES$beta["Isoprenoid",c(6,7)]<-t(summarize.results(res.article.isoprenoid,true_beta=beta_true,true_mean=mean_true,true_cor=cor_true,digits=3)$beta[2,])
  RES$beta["Isoprenoid",8]<-ICcomp$beta
  
  RES$cor["Isoprenoid",c(2,3,4)]<-c(na.omit(rowMeans(res.article.isoprenoid$cor[,,1])),cor_true)
  RES$cor["Isoprenoid",c(6,7)]<-round(100*(-1+summarize.results(res.article.isoprenoid,true_beta=beta_true,true_mean=mean_true,true_cor=cor_true)$cor[2,]/ICcomp$cor),0)
  RES$cor["Isoprenoid",8]<-round(ICcomp$cor,3)


################################## Ozone ##################################

  Ozone<-scale(read.table("http://www.agrocampus-ouest.fr/math/livreR/ozone.txt",sep=" ",header=T)[,-c(12,13)])
  Ozone<-as.data.frame(Ozone[,c(1,3,2,4:11)])
  colnames(Ozone)<-c("y",paste("x",1:(ncol(Ozone)-1),sep=""))
  S<-estim_ncp(Ozone,method="Smooth")$ncp
  methods<-2:4
  kapa<-0
  empri<-0.1*nrow(Ozone)


  cor_true<-cor(Ozone[,c(1,11)])[1,2]
  mean_true<-0
  beta_true<-summary(lm(y~x1+x4+x10,data=Ozone))$coef["x1",1]
  formule<-"y~x1+x4+x10"

  res.article.ozone<-simulate.real(don=Ozone,nsim=nsim,v.na=c(1:ncol(Ozone)),p=p,Xtild=NULL,formula=formule,S=S,m=m,v1.cor=1,v2.cor=11,methods=methods,empri=empri,verbose=T,kapa=kapa)
  
  ICcomp<-ICcc(Ozone,"y~x1+x4+x10",1,11)

  RES$mean["Ozone",1:4]<-c(na.omit(rowMeans(res.article.ozone$mean[,,1])),mean_true)
  RES$mean["Ozone",5:7]<-t(summarize.results(res.article.ozone,true_beta=beta_true,true_mean=mean_true,true_cor=cor_true,digits=3)$mean[2,])
  RES$mean["Ozone",8]<-ICcomp$mean
  
  RES$beta["Ozone",1:4]<-c(na.omit(rowMeans(res.article.ozone$beta[,,1])),beta_true)
  RES$beta["Ozone",c(5:7)]<-t(summarize.results(res.article.ozone,true_beta=beta_true,true_mean=mean_true,true_cor=cor_true,digits=3)$beta[2,])
  RES$beta["Ozone",8]<-ICcomp$beta
  
  RES$cor["Ozone",1:4]<-c(na.omit(rowMeans(res.article.ozone$cor[,,1])),cor_true)
  RES$cor["Ozone",c(5:7)]<-round(100*(-1+summarize.results(res.article.ozone,true_beta=beta_true,true_mean=mean_true,true_cor=cor_true)$cor[2,]/ICcomp$cor),0)
  RES$cor["Ozone",8]<-round(ICcomp$cor,3)
  
################################## wine ##################################

  data(wine)
  Wine<-scale(wine[,3:31])
  Wine<-as.data.frame(Wine[,c(28,23,1:22,24:27,29)])
  colnames(Wine)<-c("y",paste("x",1:(ncol(Wine)-1),sep=""))
  S<-estim_ncp(Wine,method="Smmoth")$ncp
  methods<-4

  cor_true<-cor(Wine[,c(3,18)])[1,2]
  mean_true<-0
  beta_true<-summary(lm(y~x1,data=Wine))$coef["x1",1]
  formule<-"y~x1"

  res.article.wine<-simulate.real(don=Wine,nsim=nsim,v.na=c(1:ncol(Wine)),p=p,Xtild=NULL,formule=formule,S=S,m=m,v1.cor=3,v2.cor=18,methods=methods,empri=empri,verbose=F,kapa=kapa)
  
  ICcomp<-ICcc(Wine,formule="y~x1",3,18)
  RES$mean["Wine",3:4]<-c(na.omit(rowMeans(res.article.wine$mean[,,1])),mean_true)
  RES$mean["Wine",7]<-t(summarize.results(res.article.wine,true_beta=beta_true,true_mean=mean_true,true_cor=cor_true,digits=3)$mean[2,])
  RES$mean["Wine",8]<-ICcomp$mean
  
  RES$beta["Wine",3:4]<-c(na.omit(rowMeans(res.article.wine$beta[,,1])),beta_true)
  RES$beta["Wine",7]<-t(summarize.results(res.article.wine,true_beta=beta_true,true_mean=mean_true,true_cor=cor_true,digits=3)$beta[2,])
  RES$beta["Wine",8]<-ICcomp$beta
  
  RES$cor["Wine",3:4]<-c(na.omit(rowMeans(res.article.wine$cor[,,1])),cor_true)
  RES$cor["Wine",7]<-round(100*(-1+summarize.results(res.article.wine,true_beta=beta_true,true_mean=mean_true,true_cor=cor_true)$cor[2,]/ICcomp$cor),0)
  RES$cor["Wine",8]<-round(ICcomp$cor,3)


RES<-lapply(RES,round,3)  
write.table(RES$mean,file="table_real_mean.txt",sep="&")
write.table(RES$beta,file="table_real_beta.txt",sep="&")
write.table(RES$cor,file="table_real_cor.txt",sep="&")
